#include "filechooser.moc"

string FileChooser::exec() {
  if(list.size() == 0) return "";
  if(list.size() == 1) return list[0];

  listWidget->clear();
  for(unsigned i = 0; i < list.size(); i++) {
    listWidget->addItem(list[i]);
  }
  listWidget->sortItems(Qt::AscendingOrder);
  listWidget->setCurrentRow(0);
  listWidget->setFocus();

  name = "";
  QDialog::exec();
  return name;
}

void FileChooser::load() {
  QListWidgetItem *item = listWidget->currentItem();
  if(item) name = item->text().toUtf8().constData();
  QDialog::done(0);
}

FileChooser::FileChooser() {
  setWindowTitle("Select Cartridge To Load");
  setMinimumWidth(480);
  setMinimumHeight(320);

  layout = new QVBoxLayout;
  setLayout(layout);

  listWidget = new QListWidget;
  layout->addWidget(listWidget);

  controlLayout = new QHBoxLayout;
  controlLayout->setAlignment(Qt::AlignRight);
  layout->addLayout(controlLayout);

  ok = new QPushButton("Ok");
  controlLayout->addWidget(ok);

  cancel = new QPushButton("Cancel");
  controlLayout->addWidget(cancel);

  connect(listWidget, SIGNAL(itemActivated(QListWidgetItem*)), this, SLOT(load()));
  connect(ok, SIGNAL(released()), this, SLOT(load()));
  connect(cancel, SIGNAL(released()), this, SLOT(reject()));
}
